t / perf / perf-lib.shon commit Merge branch 'sb/submodule-helper-list-signal-unmatch-via-exit-status' (f6136f3)
   1# Performance testing framework.  Each perf script starts much like
   2# a normal test script, except it sources this library instead of
   3# test-lib.sh.  See t/perf/README for documentation.
   4#
   5# Copyright (c) 2011 Thomas Rast
   6#
   7# This program is free software: you can redistribute it and/or modify
   8# it under the terms of the GNU General Public License as published by
   9# the Free Software Foundation, either version 2 of the License, or
  10# (at your option) any later version.
  11#
  12# This program is distributed in the hope that it will be useful,
  13# but WITHOUT ANY WARRANTY; without even the implied warranty of
  14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  15# GNU General Public License for more details.
  16#
  17# You should have received a copy of the GNU General Public License
  18# along with this program.  If not, see http://www.gnu.org/licenses/ .
  19
  20# do the --tee work early; it otherwise confuses our careful
  21# GIT_BUILD_DIR mangling
  22case "$GIT_TEST_TEE_STARTED, $* " in
  23done,*)
  24        # do not redirect again
  25        ;;
  26*' --tee '*|*' --va'*)
  27        mkdir -p test-results
  28        BASE=test-results/$(basename "$0" .sh)
  29        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  30         echo $? > $BASE.exit) | tee $BASE.out
  31        test "$(cat $BASE.exit)" = 0
  32        exit
  33        ;;
  34esac
  35
  36TEST_DIRECTORY=$(pwd)/..
  37TEST_OUTPUT_DIRECTORY=$(pwd)
  38if test -z "$GIT_TEST_INSTALLED"; then
  39        perf_results_prefix=
  40else
  41        perf_results_prefix=$(printf "%s" "${GIT_TEST_INSTALLED%/bin-wrappers}" | tr -c "[a-zA-Z0-9]" "[_*]")"."
  42        # make the tested dir absolute
  43        GIT_TEST_INSTALLED=$(cd "$GIT_TEST_INSTALLED" && pwd)
  44fi
  45
  46TEST_NO_CREATE_REPO=t
  47TEST_NO_MALLOC_CHECK=t
  48
  49. ../test-lib.sh
  50
  51# Variables from test-lib that are normally internal to the tests; we
  52# need to export them for test_perf subshells
  53export TEST_DIRECTORY TRASH_DIRECTORY GIT_BUILD_DIR GIT_TEST_CMP
  54
  55perf_results_dir=$TEST_OUTPUT_DIRECTORY/test-results
  56mkdir -p "$perf_results_dir"
  57rm -f "$perf_results_dir"/$(basename "$0" .sh).subtests
  58
  59if test -z "$GIT_PERF_REPEAT_COUNT"; then
  60        GIT_PERF_REPEAT_COUNT=3
  61fi
  62die_if_build_dir_not_repo () {
  63        if ! ( cd "$TEST_DIRECTORY/.." &&
  64                    git rev-parse --build-dir >/dev/null 2>&1 ); then
  65                error "No $1 defined, and your build directory is not a repo"
  66        fi
  67}
  68
  69if test -z "$GIT_PERF_REPO"; then
  70        die_if_build_dir_not_repo '$GIT_PERF_REPO'
  71        GIT_PERF_REPO=$TEST_DIRECTORY/..
  72fi
  73if test -z "$GIT_PERF_LARGE_REPO"; then
  74        die_if_build_dir_not_repo '$GIT_PERF_LARGE_REPO'
  75        GIT_PERF_LARGE_REPO=$TEST_DIRECTORY/..
  76fi
  77
  78test_perf_create_repo_from () {
  79        test "$#" = 2 ||
  80        error "bug in the test script: not 2 parameters to test-create-repo"
  81        repo="$1"
  82        source="$2"
  83        source_git="$(git -C "$source" rev-parse --git-dir)"
  84        objects_dir="$(git -C "$source" rev-parse --git-path objects)"
  85        mkdir -p "$repo/.git"
  86        (
  87                cd "$source" &&
  88                { cp -Rl "$objects_dir" "$repo/.git/" 2>/dev/null ||
  89                        cp -R "$objects_dir" "$repo/.git/"; } &&
  90                for stuff in "$source_git"/*; do
  91                        case "$stuff" in
  92                                */objects|*/hooks|*/config|*/commondir)
  93                                        ;;
  94                                *)
  95                                        cp -R "$stuff" "$repo/.git/" || exit 1
  96                                        ;;
  97                        esac
  98                done
  99        ) &&
 100        (
 101                cd "$repo" &&
 102                git init -q && {
 103                        test_have_prereq SYMLINKS ||
 104                        git config core.symlinks false
 105                } &&
 106                mv .git/hooks .git/hooks-disabled 2>/dev/null
 107        ) || error "failed to copy repository '$source' to '$repo'"
 108}
 109
 110# call at least one of these to establish an appropriately-sized repository
 111test_perf_default_repo () {
 112        test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_REPO"
 113}
 114test_perf_large_repo () {
 115        if test "$GIT_PERF_LARGE_REPO" = "$GIT_BUILD_DIR"; then
 116                echo "warning: \$GIT_PERF_LARGE_REPO is \$GIT_BUILD_DIR." >&2
 117                echo "warning: This will work, but may not be a sufficiently large repo" >&2
 118                echo "warning: for representative measurements." >&2
 119        fi
 120        test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_LARGE_REPO"
 121}
 122test_checkout_worktree () {
 123        git checkout-index -u -a ||
 124        error "git checkout-index failed"
 125}
 126
 127# Performance tests should never fail.  If they do, stop immediately
 128immediate=t
 129
 130test_run_perf_ () {
 131        test_cleanup=:
 132        test_export_="test_cleanup"
 133        export test_cleanup test_export_
 134        /usr/bin/time -f "%E %U %S" -o test_time.$i "$SHELL" -c '
 135. '"$TEST_DIRECTORY"/test-lib-functions.sh'
 136test_export () {
 137        [ $# != 0 ] || return 0
 138        test_export_="$test_export_\\|$1"
 139        shift
 140        test_export "$@"
 141}
 142'"$1"'
 143ret=$?
 144set | sed -n "s'"/'/'\\\\''/g"';s/^\\($test_export_\\)/export '"'&'"'/p" >test_vars
 145exit $ret' >&3 2>&4
 146        eval_ret=$?
 147
 148        if test $eval_ret = 0 || test -n "$expecting_failure"
 149        then
 150                test_eval_ "$test_cleanup"
 151                . ./test_vars || error "failed to load updated environment"
 152        fi
 153        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 154                echo ""
 155        fi
 156        return "$eval_ret"
 157}
 158
 159
 160test_perf () {
 161        test_start_
 162        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 163        test "$#" = 2 ||
 164        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 165        export test_prereq
 166        if ! test_skip "$@"
 167        then
 168                base=$(basename "$0" .sh)
 169                echo "$test_count" >>"$perf_results_dir"/$base.subtests
 170                echo "$1" >"$perf_results_dir"/$base.$test_count.descr
 171                if test -z "$verbose"; then
 172                        printf "%s" "perf $test_count - $1:"
 173                else
 174                        echo "perf $test_count - $1:"
 175                fi
 176                for i in $(test_seq 1 $GIT_PERF_REPEAT_COUNT); do
 177                        say >&3 "running: $2"
 178                        if test_run_perf_ "$2"
 179                        then
 180                                if test -z "$verbose"; then
 181                                        printf " %s" "$i"
 182                                else
 183                                        echo "* timing run $i/$GIT_PERF_REPEAT_COUNT:"
 184                                fi
 185                        else
 186                                test -z "$verbose" && echo
 187                                test_failure_ "$@"
 188                                break
 189                        fi
 190                done
 191                if test -z "$verbose"; then
 192                        echo " ok"
 193                else
 194                        test_ok_ "$1"
 195                fi
 196                base="$perf_results_dir"/"$perf_results_prefix$(basename "$0" .sh)"."$test_count"
 197                "$TEST_DIRECTORY"/perf/min_time.perl test_time.* >"$base".times
 198        fi
 199        test_finish_
 200}
 201
 202# We extend test_done to print timings at the end (./run disables this
 203# and does it after running everything)
 204test_at_end_hook_ () {
 205        if test -z "$GIT_PERF_AGGREGATING_LATER"; then
 206                ( cd "$TEST_DIRECTORY"/perf && ./aggregate.perl $(basename "$0") )
 207        fi
 208}
 209
 210test_export () {
 211        export "$@"
 212}